package com.ruoyi.web.yh.report.service.impl;

import com.ruoyi.common.utils.collection.CollectionUtils;
import com.ruoyi.web.yh.report.domain.ReportVO;
import com.ruoyi.web.yh.report.service.ReportAssembler;
import com.ruoyi.web.yh.report.service.ReportService;
import com.ruoyi.web.yh.reportProd.domain.ReportProdQuery;
import com.ruoyi.web.yh.reportProd.domain.ReportProdVO;
import com.ruoyi.web.yh.reportProd.service.ReportProdService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author wjh
 * 2024/10/31
 */
@Service
public class ReportAssemblerImpl implements ReportAssembler {

    @Autowired
    private ReportService reportService;

    @Autowired
    private ReportProdService reportProdService;

    @Override
    public void assembleProductList(List<ReportVO> list) {
        if (CollectionUtils.isEmptyElement(list)) {
            return;
        }
        ReportProdQuery query = new ReportProdQuery();
        query.setReportIds(CollectionUtils.map(list, ReportVO::getReportId));
        Map<Long, List<ReportProdVO>> group = reportProdService.selectReportProdList(query)
                .stream().collect(Collectors.groupingBy(ReportProdVO::getReportId));

        for (ReportVO report : list) {
            List<ReportProdVO> productList = group.get(report.getReportId());
            if (productList == null) {
                productList = new ArrayList<>();
            }
            report.setProductList(productList);
        }
    }
}
