package com.ruoyi.web.yh.report.service.impl;

import com.ruoyi.common.core.domain.model.LoginUser;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.system.service.ISysUserService;
import com.ruoyi.web.yh.price.domain.PriceQuery;
import com.ruoyi.web.yh.price.service.PriceService;
import com.ruoyi.web.yh.report.domain.Report;
import com.ruoyi.web.yh.report.domain.ReportVO;
import com.ruoyi.web.yh.report.domain.bo.ReportBO;
import com.ruoyi.web.yh.report.domain.enums.ReportStatus;
import com.ruoyi.web.yh.report.service.ReportConverter;
import com.ruoyi.web.yh.reportProd.domain.ReportProd;
import com.ruoyi.web.yh.reportProd.domain.ReportProdVO;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @author wjh
 * 2024/10/31
 */
@Service
public class ReportConverterImpl implements ReportConverter {

    @Autowired
    private ISysUserService userService;

    @Autowired
    private PriceService priceService;

    @Override
    public ReportBO toBoByCreate(ReportVO vo) {
        if (vo == null) {
            return null;
        }

        LoginUser loginUser = SecurityUtils.getLoginUser();

        // 报表主表数据
        Report report = new Report();
        report.setDeptId(vo.getDeptId());
        report.setStatus(ReportStatus.WAIT_VERIFY.getStatus());
        report.setCreateId(loginUser.getUserId());
        report.setReportDate(vo.getReportDate());
        report.setTotalAmount(vo.getTotalAmount());
        report.setCreateBy(loginUser.getNickName());

        // 报表产量数据
        List<ReportProd> productList = new ArrayList<>();
        if (CollectionUtils.isNotEmpty(vo.getProductList())) {
            for (ReportProdVO item : vo.getProductList()) {
                ReportProd prod = new ReportProd();
                prod.setPriceId(item.getPriceId());
                prod.setNum(item.getNum());
                prod.setPriceCategory(item.getPriceCategory());
                prod.setPriceSize(item.getPriceSize());
                prod.setPriceName(item.getPriceName());
                prod.setPriceSubName(item.getPriceSubName());
                prod.setPricePattern(item.getPricePattern());
                prod.setPriceSpec(item.getPriceSpec());
                prod.setPricePrice(item.getPricePrice());
                prod.setPriceUnit(item.getPriceUnit());
                prod.setPriceClassify(item.getPriceClassify());
                prod.setPriceQuantity(item.getPriceQuantity());
                productList.add(prod);
            }
        }

        // 组装数据
        ReportBO bo = new ReportBO();
        bo.setReport(report);
        bo.setProductList(productList);
        return bo;
    }
}
